/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  PayableOverrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import { TypedEventFilter, TypedEvent, TypedListener } from "./commons";

interface IWormholeInterface extends ethers.utils.Interface {
  functions: {
    "publishMessage(uint32,bytes,uint8)": FunctionFragment;
    "parseAndVerifyVM(bytes)": FunctionFragment;
    "verifyVM(tuple)": FunctionFragment;
    "verifySignatures(bytes32,tuple[],tuple)": FunctionFragment;
    "parseVM(bytes)": FunctionFragment;
    "getGuardianSet(uint32)": FunctionFragment;
    "getCurrentGuardianSetIndex()": FunctionFragment;
    "getGuardianSetExpiry()": FunctionFragment;
    "governanceActionIsConsumed(bytes32)": FunctionFragment;
    "isInitialized(address)": FunctionFragment;
    "chainId()": FunctionFragment;
    "governanceChainId()": FunctionFragment;
    "governanceContract()": FunctionFragment;
    "messageFee()": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "publishMessage",
    values: [BigNumberish, BytesLike, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "parseAndVerifyVM",
    values: [BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "verifyVM",
    values: [
      {
        version: BigNumberish;
        timestamp: BigNumberish;
        nonce: BigNumberish;
        emitterChainId: BigNumberish;
        emitterAddress: BytesLike;
        sequence: BigNumberish;
        consistencyLevel: BigNumberish;
        payload: BytesLike;
        guardianSetIndex: BigNumberish;
        signatures: {
          r: BytesLike;
          s: BytesLike;
          v: BigNumberish;
          guardianIndex: BigNumberish;
        }[];
        hash: BytesLike;
      }
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "verifySignatures",
    values: [
      BytesLike,
      {
        r: BytesLike;
        s: BytesLike;
        v: BigNumberish;
        guardianIndex: BigNumberish;
      }[],
      { keys: string[]; expirationTime: BigNumberish }
    ]
  ): string;
  encodeFunctionData(functionFragment: "parseVM", values: [BytesLike]): string;
  encodeFunctionData(
    functionFragment: "getGuardianSet",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getCurrentGuardianSetIndex",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getGuardianSetExpiry",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "governanceActionIsConsumed",
    values: [BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "isInitialized",
    values: [string]
  ): string;
  encodeFunctionData(functionFragment: "chainId", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "governanceChainId",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "governanceContract",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "messageFee",
    values?: undefined
  ): string;

  decodeFunctionResult(
    functionFragment: "publishMessage",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "parseAndVerifyVM",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "verifyVM", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "verifySignatures",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "parseVM", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "getGuardianSet",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getCurrentGuardianSetIndex",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getGuardianSetExpiry",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "governanceActionIsConsumed",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isInitialized",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "chainId", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "governanceChainId",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "governanceContract",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "messageFee", data: BytesLike): Result;

  events: {
    "LogMessagePublished(address,uint64,uint32,bytes,uint8)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "LogMessagePublished"): EventFragment;
}

export class IWormhole extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: IWormholeInterface;

  functions: {
    publishMessage(
      nonce: BigNumberish,
      payload: BytesLike,
      consistencyLevel: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    parseAndVerifyVM(
      encodedVM: BytesLike,
      overrides?: CallOverrides
    ): Promise<
      [
        [
          number,
          number,
          number,
          number,
          string,
          BigNumber,
          number,
          string,
          number,
          ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[],
          string
        ] & {
          version: number;
          timestamp: number;
          nonce: number;
          emitterChainId: number;
          emitterAddress: string;
          sequence: BigNumber;
          consistencyLevel: number;
          payload: string;
          guardianSetIndex: number;
          signatures: ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[];
          hash: string;
        },
        boolean,
        string
      ] & {
        vm: [
          number,
          number,
          number,
          number,
          string,
          BigNumber,
          number,
          string,
          number,
          ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[],
          string
        ] & {
          version: number;
          timestamp: number;
          nonce: number;
          emitterChainId: number;
          emitterAddress: string;
          sequence: BigNumber;
          consistencyLevel: number;
          payload: string;
          guardianSetIndex: number;
          signatures: ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[];
          hash: string;
        };
        valid: boolean;
        reason: string;
      }
    >;

    verifyVM(
      vm: {
        version: BigNumberish;
        timestamp: BigNumberish;
        nonce: BigNumberish;
        emitterChainId: BigNumberish;
        emitterAddress: BytesLike;
        sequence: BigNumberish;
        consistencyLevel: BigNumberish;
        payload: BytesLike;
        guardianSetIndex: BigNumberish;
        signatures: {
          r: BytesLike;
          s: BytesLike;
          v: BigNumberish;
          guardianIndex: BigNumberish;
        }[];
        hash: BytesLike;
      },
      overrides?: CallOverrides
    ): Promise<[boolean, string] & { valid: boolean; reason: string }>;

    verifySignatures(
      hash: BytesLike,
      signatures: {
        r: BytesLike;
        s: BytesLike;
        v: BigNumberish;
        guardianIndex: BigNumberish;
      }[],
      guardianSet: { keys: string[]; expirationTime: BigNumberish },
      overrides?: CallOverrides
    ): Promise<[boolean, string] & { valid: boolean; reason: string }>;

    parseVM(
      encodedVM: BytesLike,
      overrides?: CallOverrides
    ): Promise<
      [
        [
          number,
          number,
          number,
          number,
          string,
          BigNumber,
          number,
          string,
          number,
          ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[],
          string
        ] & {
          version: number;
          timestamp: number;
          nonce: number;
          emitterChainId: number;
          emitterAddress: string;
          sequence: BigNumber;
          consistencyLevel: number;
          payload: string;
          guardianSetIndex: number;
          signatures: ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[];
          hash: string;
        }
      ] & {
        vm: [
          number,
          number,
          number,
          number,
          string,
          BigNumber,
          number,
          string,
          number,
          ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[],
          string
        ] & {
          version: number;
          timestamp: number;
          nonce: number;
          emitterChainId: number;
          emitterAddress: string;
          sequence: BigNumber;
          consistencyLevel: number;
          payload: string;
          guardianSetIndex: number;
          signatures: ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[];
          hash: string;
        };
      }
    >;

    getGuardianSet(
      index: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [[string[], number] & { keys: string[]; expirationTime: number }]
    >;

    getCurrentGuardianSetIndex(overrides?: CallOverrides): Promise<[number]>;

    getGuardianSetExpiry(overrides?: CallOverrides): Promise<[number]>;

    governanceActionIsConsumed(
      hash: BytesLike,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    isInitialized(impl: string, overrides?: CallOverrides): Promise<[boolean]>;

    chainId(overrides?: CallOverrides): Promise<[number]>;

    governanceChainId(overrides?: CallOverrides): Promise<[number]>;

    governanceContract(overrides?: CallOverrides): Promise<[string]>;

    messageFee(overrides?: CallOverrides): Promise<[BigNumber]>;
  };

  publishMessage(
    nonce: BigNumberish,
    payload: BytesLike,
    consistencyLevel: BigNumberish,
    overrides?: PayableOverrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  parseAndVerifyVM(
    encodedVM: BytesLike,
    overrides?: CallOverrides
  ): Promise<
    [
      [
        number,
        number,
        number,
        number,
        string,
        BigNumber,
        number,
        string,
        number,
        ([string, string, number, number] & {
          r: string;
          s: string;
          v: number;
          guardianIndex: number;
        })[],
        string
      ] & {
        version: number;
        timestamp: number;
        nonce: number;
        emitterChainId: number;
        emitterAddress: string;
        sequence: BigNumber;
        consistencyLevel: number;
        payload: string;
        guardianSetIndex: number;
        signatures: ([string, string, number, number] & {
          r: string;
          s: string;
          v: number;
          guardianIndex: number;
        })[];
        hash: string;
      },
      boolean,
      string
    ] & {
      vm: [
        number,
        number,
        number,
        number,
        string,
        BigNumber,
        number,
        string,
        number,
        ([string, string, number, number] & {
          r: string;
          s: string;
          v: number;
          guardianIndex: number;
        })[],
        string
      ] & {
        version: number;
        timestamp: number;
        nonce: number;
        emitterChainId: number;
        emitterAddress: string;
        sequence: BigNumber;
        consistencyLevel: number;
        payload: string;
        guardianSetIndex: number;
        signatures: ([string, string, number, number] & {
          r: string;
          s: string;
          v: number;
          guardianIndex: number;
        })[];
        hash: string;
      };
      valid: boolean;
      reason: string;
    }
  >;

  verifyVM(
    vm: {
      version: BigNumberish;
      timestamp: BigNumberish;
      nonce: BigNumberish;
      emitterChainId: BigNumberish;
      emitterAddress: BytesLike;
      sequence: BigNumberish;
      consistencyLevel: BigNumberish;
      payload: BytesLike;
      guardianSetIndex: BigNumberish;
      signatures: {
        r: BytesLike;
        s: BytesLike;
        v: BigNumberish;
        guardianIndex: BigNumberish;
      }[];
      hash: BytesLike;
    },
    overrides?: CallOverrides
  ): Promise<[boolean, string] & { valid: boolean; reason: string }>;

  verifySignatures(
    hash: BytesLike,
    signatures: {
      r: BytesLike;
      s: BytesLike;
      v: BigNumberish;
      guardianIndex: BigNumberish;
    }[],
    guardianSet: { keys: string[]; expirationTime: BigNumberish },
    overrides?: CallOverrides
  ): Promise<[boolean, string] & { valid: boolean; reason: string }>;

  parseVM(
    encodedVM: BytesLike,
    overrides?: CallOverrides
  ): Promise<
    [
      number,
      number,
      number,
      number,
      string,
      BigNumber,
      number,
      string,
      number,
      ([string, string, number, number] & {
        r: string;
        s: string;
        v: number;
        guardianIndex: number;
      })[],
      string
    ] & {
      version: number;
      timestamp: number;
      nonce: number;
      emitterChainId: number;
      emitterAddress: string;
      sequence: BigNumber;
      consistencyLevel: number;
      payload: string;
      guardianSetIndex: number;
      signatures: ([string, string, number, number] & {
        r: string;
        s: string;
        v: number;
        guardianIndex: number;
      })[];
      hash: string;
    }
  >;

  getGuardianSet(
    index: BigNumberish,
    overrides?: CallOverrides
  ): Promise<[string[], number] & { keys: string[]; expirationTime: number }>;

  getCurrentGuardianSetIndex(overrides?: CallOverrides): Promise<number>;

  getGuardianSetExpiry(overrides?: CallOverrides): Promise<number>;

  governanceActionIsConsumed(
    hash: BytesLike,
    overrides?: CallOverrides
  ): Promise<boolean>;

  isInitialized(impl: string, overrides?: CallOverrides): Promise<boolean>;

  chainId(overrides?: CallOverrides): Promise<number>;

  governanceChainId(overrides?: CallOverrides): Promise<number>;

  governanceContract(overrides?: CallOverrides): Promise<string>;

  messageFee(overrides?: CallOverrides): Promise<BigNumber>;

  callStatic: {
    publishMessage(
      nonce: BigNumberish,
      payload: BytesLike,
      consistencyLevel: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    parseAndVerifyVM(
      encodedVM: BytesLike,
      overrides?: CallOverrides
    ): Promise<
      [
        [
          number,
          number,
          number,
          number,
          string,
          BigNumber,
          number,
          string,
          number,
          ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[],
          string
        ] & {
          version: number;
          timestamp: number;
          nonce: number;
          emitterChainId: number;
          emitterAddress: string;
          sequence: BigNumber;
          consistencyLevel: number;
          payload: string;
          guardianSetIndex: number;
          signatures: ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[];
          hash: string;
        },
        boolean,
        string
      ] & {
        vm: [
          number,
          number,
          number,
          number,
          string,
          BigNumber,
          number,
          string,
          number,
          ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[],
          string
        ] & {
          version: number;
          timestamp: number;
          nonce: number;
          emitterChainId: number;
          emitterAddress: string;
          sequence: BigNumber;
          consistencyLevel: number;
          payload: string;
          guardianSetIndex: number;
          signatures: ([string, string, number, number] & {
            r: string;
            s: string;
            v: number;
            guardianIndex: number;
          })[];
          hash: string;
        };
        valid: boolean;
        reason: string;
      }
    >;

    verifyVM(
      vm: {
        version: BigNumberish;
        timestamp: BigNumberish;
        nonce: BigNumberish;
        emitterChainId: BigNumberish;
        emitterAddress: BytesLike;
        sequence: BigNumberish;
        consistencyLevel: BigNumberish;
        payload: BytesLike;
        guardianSetIndex: BigNumberish;
        signatures: {
          r: BytesLike;
          s: BytesLike;
          v: BigNumberish;
          guardianIndex: BigNumberish;
        }[];
        hash: BytesLike;
      },
      overrides?: CallOverrides
    ): Promise<[boolean, string] & { valid: boolean; reason: string }>;

    verifySignatures(
      hash: BytesLike,
      signatures: {
        r: BytesLike;
        s: BytesLike;
        v: BigNumberish;
        guardianIndex: BigNumberish;
      }[],
      guardianSet: { keys: string[]; expirationTime: BigNumberish },
      overrides?: CallOverrides
    ): Promise<[boolean, string] & { valid: boolean; reason: string }>;

    parseVM(
      encodedVM: BytesLike,
      overrides?: CallOverrides
    ): Promise<
      [
        number,
        number,
        number,
        number,
        string,
        BigNumber,
        number,
        string,
        number,
        ([string, string, number, number] & {
          r: string;
          s: string;
          v: number;
          guardianIndex: number;
        })[],
        string
      ] & {
        version: number;
        timestamp: number;
        nonce: number;
        emitterChainId: number;
        emitterAddress: string;
        sequence: BigNumber;
        consistencyLevel: number;
        payload: string;
        guardianSetIndex: number;
        signatures: ([string, string, number, number] & {
          r: string;
          s: string;
          v: number;
          guardianIndex: number;
        })[];
        hash: string;
      }
    >;

    getGuardianSet(
      index: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[string[], number] & { keys: string[]; expirationTime: number }>;

    getCurrentGuardianSetIndex(overrides?: CallOverrides): Promise<number>;

    getGuardianSetExpiry(overrides?: CallOverrides): Promise<number>;

    governanceActionIsConsumed(
      hash: BytesLike,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isInitialized(impl: string, overrides?: CallOverrides): Promise<boolean>;

    chainId(overrides?: CallOverrides): Promise<number>;

    governanceChainId(overrides?: CallOverrides): Promise<number>;

    governanceContract(overrides?: CallOverrides): Promise<string>;

    messageFee(overrides?: CallOverrides): Promise<BigNumber>;
  };

  filters: {
    LogMessagePublished(
      sender?: string | null,
      sequence?: null,
      nonce?: null,
      payload?: null,
      consistencyLevel?: null
    ): TypedEventFilter<
      [string, BigNumber, number, string, number],
      {
        sender: string;
        sequence: BigNumber;
        nonce: number;
        payload: string;
        consistencyLevel: number;
      }
    >;
  };

  estimateGas: {
    publishMessage(
      nonce: BigNumberish,
      payload: BytesLike,
      consistencyLevel: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    parseAndVerifyVM(
      encodedVM: BytesLike,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    verifyVM(
      vm: {
        version: BigNumberish;
        timestamp: BigNumberish;
        nonce: BigNumberish;
        emitterChainId: BigNumberish;
        emitterAddress: BytesLike;
        sequence: BigNumberish;
        consistencyLevel: BigNumberish;
        payload: BytesLike;
        guardianSetIndex: BigNumberish;
        signatures: {
          r: BytesLike;
          s: BytesLike;
          v: BigNumberish;
          guardianIndex: BigNumberish;
        }[];
        hash: BytesLike;
      },
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    verifySignatures(
      hash: BytesLike,
      signatures: {
        r: BytesLike;
        s: BytesLike;
        v: BigNumberish;
        guardianIndex: BigNumberish;
      }[],
      guardianSet: { keys: string[]; expirationTime: BigNumberish },
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    parseVM(
      encodedVM: BytesLike,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getGuardianSet(
      index: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getCurrentGuardianSetIndex(overrides?: CallOverrides): Promise<BigNumber>;

    getGuardianSetExpiry(overrides?: CallOverrides): Promise<BigNumber>;

    governanceActionIsConsumed(
      hash: BytesLike,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isInitialized(impl: string, overrides?: CallOverrides): Promise<BigNumber>;

    chainId(overrides?: CallOverrides): Promise<BigNumber>;

    governanceChainId(overrides?: CallOverrides): Promise<BigNumber>;

    governanceContract(overrides?: CallOverrides): Promise<BigNumber>;

    messageFee(overrides?: CallOverrides): Promise<BigNumber>;
  };

  populateTransaction: {
    publishMessage(
      nonce: BigNumberish,
      payload: BytesLike,
      consistencyLevel: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    parseAndVerifyVM(
      encodedVM: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    verifyVM(
      vm: {
        version: BigNumberish;
        timestamp: BigNumberish;
        nonce: BigNumberish;
        emitterChainId: BigNumberish;
        emitterAddress: BytesLike;
        sequence: BigNumberish;
        consistencyLevel: BigNumberish;
        payload: BytesLike;
        guardianSetIndex: BigNumberish;
        signatures: {
          r: BytesLike;
          s: BytesLike;
          v: BigNumberish;
          guardianIndex: BigNumberish;
        }[];
        hash: BytesLike;
      },
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    verifySignatures(
      hash: BytesLike,
      signatures: {
        r: BytesLike;
        s: BytesLike;
        v: BigNumberish;
        guardianIndex: BigNumberish;
      }[],
      guardianSet: { keys: string[]; expirationTime: BigNumberish },
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    parseVM(
      encodedVM: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getGuardianSet(
      index: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getCurrentGuardianSetIndex(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getGuardianSetExpiry(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    governanceActionIsConsumed(
      hash: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isInitialized(
      impl: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    chainId(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    governanceChainId(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    governanceContract(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    messageFee(overrides?: CallOverrides): Promise<PopulatedTransaction>;
  };
}
